#!/bin/bash
# a menu driven system information program

main() {
    while true; do
        display_menu
        read -p "Enter selection [A, B, C or Q] > "
        echo
        process_selection $REPLY
        echo
        read -p "Press <enter> to continue..."
    done
}

display_menu() {
    clear
    cat <<_EOF_

A. Display System Information
B. Display Disk Space Utilization
C. Display Home Space Utilization
Q. Quit

_EOF_
}

process_selection() {
    local selection=$1
    case $selection in
        q|Q)  echo -e "Program terminated. \n"
              exit
              ;;
        a|A)  echo -e "A. System Information \n"
              echo Hostname: $HOSTNAME
              uptime
              ;;
        b|B)  echo -e "B. Disk Space Utilization \n"
              df -h .
              ;;
        c|C)  echo -e "C. Home Space Utilization \n"
              display_home_space_utilization
              ;;
        *)    echo "Invalid entry: '$selection'"
              ;;
    esac
}

display_home_space_utilization() {
    if [[ "$(id -u)" -eq 0 ]]; then
        echo "Home Space Utilization (All Users)"
        du -sh /home/*
    else
        echo "Home Space Utilization ($USER)"
        du -sh $HOME
    fi
}

# call main
main "$@"
